(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



LGSBlochInitwasLoaded=AbsoluteTime[];
Off[Void::shdw];
Off[Set::write];
Off[SetDelayed::write];
Get["AtomicDensityMatrix`LGSBloch`"]//Quiet;

ClearAll[initLGSBloch];
initLGSBloch[neglectHfs_:True]:=Module[{initFileName,loadEqns,rval,rr},
(* file name to store Bloch equation system *)
initFileName = ToFileName[TmpDir,"NaD2LGS_" <> If[neglectHfs,"","hfs_"] <> $System <> ".mx"];

(* Load system if it exists, is large enough, and is newer than LGSBloch.m, otherwise compute it *)
NaD2LGS={};
loadEqns = If[FileExistsQ[initFileName],
If[FileByteCount[initFileName]>2000&&
AbsoluteTime[FileDate[FindFile["AtomicDensityMatrix/LGSBloch.m"]]] < AbsoluteTime[FileDate[initFileName]],
Get[initFileName];
If[Dimensions[NaD2LGS] == {11},True,False]
,
Print[initFileName," is outdated or too small, recomputing"];False]
,
False];

If[loadEqns,
Print["initLGSBloch[]: Loading Bloch equation file ", initFileName];
Get[initFileName]
,
Print["initLGSBloch[]: Computing Bloch equation system. This may take a few minutes..."];
NaD2LGS = GenerateLGSSystem[NeglectHyperfineCoherences->neglectHfs];
DumpSave[initFileName, NaD2LGS];
Print["...done. Saved Bloch equation system to ", initFileName, "."];
];

(* test simulation. Slightly higher return if NeglectHyperfineCoherences True (density matrix blocks have 576 dimensions then, up from 322) *)
rval=If[neglectHfs, 262.095, 260.881];
rr=PsiMeso[NaD2LGS, {IMeso->46.0,RepumpFraction->0.12,BG->BGParanal}];
Print["initLGSBloch[]: Test result psi: ", rr, " ph/s/sr/(W/m^2)"];

If[Abs[rr-rval]/rval < 0.001,
Print["Test result ok, ready to go! hfs: ", !neglectHfs];
,
Print["Test result should have been ", rval, ", suspecting error, Aborting"];
NaD2LGS={};
Abort[];
];

];(* End of module *)


(* Now execute the initialization *)
initLGSBloch[];
On[Void::shdw];
On[Set::write];
On[SetDelayed::write];
